Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs	(revision 8841)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs	(revision 8841)
@@ -0,0 +1,41 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Iris : IDataDescriptor {
+    public string Name { get { return "Iris"; } }
+    public string Description {
+      get {
+        return "Data Set Information:" + Environment.NewLine
+        + "This is perhaps the best known database to be found in the pattern " + Environment.NewLine
+        + "recognition literature. Fisher's paper is a classic in the field and "
+        + "is referenced frequently to this day. (See Duda & Hart, for example.) "
+        + "The data set contains 3 classes of 50 instances each, where each class "
+        + "refers to a type of iris plant. One class is linearly separable from the "
+        + "other 2; the latter are NOT linearly separable from each other." + Environment.NewLine
+        + "Predicted attribute: class of iris plant." + Environment.NewLine
+        + "This is an exceedingly simple domain.";
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs	(revision 8841)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs	(revision 8841)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Thyroid : IDataDescriptor {
+    public string Name { get { return "Thyroid"; } }
+    public string Description {
+      get {
+        return "Thyroid gland data. ('normal', hypo and hyper functioning)" + Environment.NewLine + Environment.NewLine +
+        "Attr. no :" + Environment.NewLine +
+        "1: Class attribute (1 = normal, 2 = hyper, 3 = hypo)" + Environment.NewLine +
+        "2: T3-resin uptake test. (A percentage)" + Environment.NewLine +
+        "3: Total Serum thyroxin as measured by the isotopic displacement method." + Environment.NewLine +
+        "4: Total serum triiodothyronine as measured by radioimmuno	assay." + Environment.NewLine +
+        "5: basal thyroid-stimulating hormone (TSH) as measured by radioimmuno assay." + Environment.NewLine +
+        "6: Maximal absolute difference of TSH value after injection of 200 micro grams of " +
+        "thyrotropin-releasing hormone as compared to the basal value." + Environment.NewLine +
+        "All attributes are continuous.";
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 8840)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 8841)
@@ -47,5 +47,7 @@
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       List<IDataDescriptor> descriptorList = new List<IDataDescriptor>();
+      descriptorList.Add(new Iris());
       descriptorList.Add(new Mammography());
+      descriptorList.Add(new Thyroid());
       descriptorList.Add(new Wine());
       var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8840)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8841)
@@ -119,5 +119,7 @@
     <Compile Include="Classification\ResourceClassificationDataDescriptor.cs" />
     <Compile Include="Classification\ResourceClassificationInstanceProvider.cs" />
+    <Compile Include="Classification\UCI\Iris.cs" />
     <Compile Include="Classification\UCI\Mammography.cs" />
+    <Compile Include="Classification\UCI\Thyroid.cs" />
     <Compile Include="Classification\UCI\UCIInstanceProvider.cs" />
     <Compile Include="Classification\UCI\Wine.cs" />