Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.Designer.cs	(revision 8869)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.Designer.cs	(revision 8870)
@@ -26,4 +26,6 @@
       components = new System.ComponentModel.Container();
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Text = "Show/Hide Columns";
+      this.Name = "ColumnsVisibilityDialog";
     }
 
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.cs	(revision 8869)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.cs	(revision 8870)
@@ -31,4 +31,5 @@
     public StringConvertibleMatrixColumnVisibilityDialog(IEnumerable<DataGridViewColumn> columns)
       : base(columns) {
+      InitializeComponent();
     }
 
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.Designer.cs	(revision 8869)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.Designer.cs	(revision 8870)
@@ -26,5 +26,6 @@
       this.components = new System.ComponentModel.Container();
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Text = "StringConvertibleMatrixRowVisibilityDialog";
+      this.Text = "Show/Hide Rows";
+      this.Name = "RowsVisibilityDialog";
     }
 
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.cs	(revision 8869)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.cs	(revision 8870)
@@ -31,4 +31,5 @@
     public StringConvertibleMatrixRowVisibilityDialog(IEnumerable<DataGridViewRow> rows)
       : base(rows) {
+      InitializeComponent();
     }
 
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.Designer.cs	(revision 8869)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.Designer.cs	(revision 8870)
@@ -99,5 +99,5 @@
       this.ShowInTaskbar = false;
       this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
-      this.Text = "Show/Hide Columns";
+      this.Text = "Show/Hide";
       this.ResumeLayout(false);
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/EnhancedStringConvertibleMatrixView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/EnhancedStringConvertibleMatrixView.cs	(revision 8869)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/EnhancedStringConvertibleMatrixView.cs	(revision 8870)
@@ -67,12 +67,14 @@
     }
     protected override void UpdateRowHeaders() {
-      base.UpdateRowHeaders();
       if (rowVisibility != null && Content != null && rowVisibility.Count() == dataGridView.RowCount) {
-        int i = 0;
-        foreach (var visibility in rowVisibility) {
-          dataGridView.Rows[i].Visible = visibility;
-          i++;
+        int[] realRowIndex = Enumerable.Range(0, Content.Rows).ToArray();
+        int[] helper = new int[virtualRowIndices.Length];
+        Array.Copy(virtualRowIndices, helper, virtualRowIndices.Length);
+        Array.Sort(helper, realRowIndex);
+        for (int i = 0; i < dataGridView.RowCount; i++) {
+          dataGridView.Rows[realRowIndex[i]].Visible = rowVisibility.ElementAt(i);
         }
       }
+      base.UpdateRowHeaders();
     }
 